extern double TakeProfit = 0;
extern double StopLoss = 0;
extern double Lots = 0.1;
extern int Fast=5;
extern int Slow=8;
extern int ADXPeriod=14;
extern int ADXSmooth=10;

datetime NewTime=0;
double MaFast, PrevMaFast, MaSlow, PrevMaSlow;
double PlusDI, MinDI, PrevPlusDI, PrevMinDI;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int ticket, cnt, total;
   if(NewTime!=Time[0])
   {
     NewTime=Time[0];

     PrevMaFast = MaFast;
     PrevMaSlow=MaSlow;
     PrevPlusDI=PlusDI;
     PrevMinDI=MinDI;
     
     MaFast = iMA(NULL,0,Fast,0,MODE_EMA,PRICE_CLOSE,1);
     MaSlow = iMA(NULL,0,Slow,0,MODE_EMA,PRICE_CLOSE,1);
     PlusDI = iCustom(NULL,0,"ADXDMI",ADXPeriod,ADXSmooth,0,1);
     MinDI = iCustom(NULL,0,"ADXDMI",ADXPeriod,ADXSmooth,1,1);
     
     total=OrdersTotal();
     
     for(cnt=0;cnt<total;cnt++)
       {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
          {
           if(OrderType()==OP_BUY)   // long position is opened
             {
              if(MaFast<MaSlow || PlusDI<MinDI)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                }
             }
           else // go to short position
             {
              if(MaFast>MaSlow || PlusDI>MinDI)
                { 
                 OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
                }
             }
          }
       }     
     
     total=OrdersTotal();
     if(total>0) return;
     if(MaFast>MaSlow && PlusDI>MinDI && PrevPlusDI<PrevMinDI)
       {
        ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"My EA",16384,0,Green);
        if(ticket>0)
          {
           if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
          }
        else Print("Error opening BUY order : ",GetLastError()); 
        return(0); 
       }

     if(MaFast<MaSlow && PlusDI<MinDI && PrevPlusDI>PrevMinDI)
       {
        ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"My EA",16384,0,Red);
        if(ticket>0)
          {
           if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
          }
        else Print("Error opening SELL order : ",GetLastError()); 
        return(0); 
       }
    }
   return(0);
  }

